consumption <- read.table("AWMDat_consumption.csv");
PYR <- consumption$PYR/1000;
PCR <- consumption$PCR/1000;

X <- (PYR[5:length(PYR)]-PYR[1:(length(PYR)-4)])/PYR[1:(length(PYR)-4)];
Y <- (PCR[5:length(PCR)]-PCR[1:(length(PCR)-4)])/PCR[1:(length(PCR)-4)];

#a
plot(Y~X);
lm<-lm(Y~X);
lm
abline(lm);

#b
N = length(X);
alpha <- lm$coefficients['(Intercept)'];
beta <- lm$coefficients['X'];
yi_hat <- 1:N;
for(i in 1:N){
  yi_hat[i] <- (alpha + beta * X[i]);
}
ui_hat <- 1:N;
for(i in 1:N){
  ui_hat[i] <- (Y[i] - yi_hat[i]);
}
ui_hat;
plot(ui_hat~X);

#c
sum_residuals = sum(ui_hat[1:N]);
sum_residuals;

#d
summary(lm);
