#5.1
bwght = read.table("bwght.csv", sep = ",",header=TRUE)

#a
lm<-lm(bwght ~ cigs + faminc, data=bwght)
lm
summary(lm)

#plot(bwght ~ cigs + faminc, data=bwght)

n=length(bwght$bwght);

onecolumn=matrix(c(1),nrow = n);
k=3;

X = matrix(c(onecolumn,bwght$cigs,bwght$faminc),ncol=k,nrow=n);
b_hat <- matrix(c(lm$coefficients['(Intercept)'],lm$coefficients['cigs'],lm$coefficients['faminc']),nrow=k);

y_hat = X %*% b_hat;
u_i_hat = bwght$bwght - y_hat;

sigma_hat_squared = (1/(n-k)) * sum(u_i_hat^2);
sigma_hat = sqrt(sigma_hat_squared)
sigma_hat # residual standard error, n-k degrees of freedom

#b
library(MASS)
VC_beta_hat = sigma_hat_squared *  ginv(t(X) %*% X);
VC_beta_hat # Std. Error, sqrt der VC-Diagonale

#c prediction
x_f = c(1,0,30);
expected_value = t(x_f) %*% b_hat;
expected_value
sigma = sqrt(sigma_hat_squared %*% t(x_f) %*% ginv(t(X) %*% X) %*% x_f);
sigma

x_f = c(1,20,30);
expected_value = t(x_f) %*% b_hat;
expected_value
sigma = sqrt(sigma_hat_squared %*% t(x_f) %*% ginv(t(X) %*% X) %*% x_f);
sigma

#5.2
lm<-lm(bwghtlbs ~ cigs + faminc, data=bwght) #lb = pound
lm
summary(lm)
#Multiple R-squared: 0.0298 -> 0.0298

#5.3
#changed "." to "NA", "," to "." and converted xls to csv manually
lawschool = read.table("lawschool.csv", sep = ";") 
GPA <- lawschool$V5
LSAT <- lawschool$V4
llibvol <- lawschool$V20
lcost <- lawschool$V21
rank <- lawschool$V1
lsalary <- lawschool$V14
lm<-lm(lsalary ~ GPA + LSAT + llibvol + lcost + rank) # + ui -> Residual standard error in output?
summary(lm)

lm<-lm(lsalary ~ LSAT + llibvol + lcost + rank)
summary(lm)
#LSAT: 0.0046964 -> 0.0112920, because they correlate very much

#plot(lsalary ~ GPA + LSAT + llibvol + lcost + rank)

#5.4
rank_tenth=rank/10;
lm<-lm(lsalary ~ GPA + LSAT + llibvol + lcost + rank_tenth)
summary(lm)
#R^2: 0.8417 -> 0.8417
