#data 6.1 - 6.4
wagedata = read.table("wage_full.csv")

#6.1
lm<-lm(log(wage) ~ educ + exper + tenure, data = wagedata)
summary(lm)

n=length(wagedata$wage);

onecolumn=matrix(c(1),nrow = n);
k=4;
X = matrix(c(onecolumn,wagedata$educ,wagedata$exper, wagedata$tenure),ncol=k,nrow=n);
beta_hat <- matrix(c(lm$coefficients['(Intercept)'],lm$coefficients['educ'],lm$coefficients['exper'],lm$coefficients['tenure']),nrow=k);

#sigma_hat as in exercise 5
y_hat = X %*% beta_hat;
u_i_hat = log(wagedata$wage) - y_hat;
sigma_hat_squared = (1/(n-k)) * sum(u_i_hat^2);
sigma_hat = sqrt(sigma_hat_squared)
sigma_hat # residual standard error, n-k degrees of freedom

#H0 : beta_j = beta_star versus H1 : beta_j != beta_star
beta_star = 0
j=4 # j= 1,..,4
library(MASS)
xi_hat= ginv(t(X) %*% X)
T = (beta_hat[j] - beta_star) / (sigma_hat * sqrt(xi_hat[j,j]) )
T

j=2
sigma_hat * sqrt(xi_hat[j,j])

#If |T| > c_alpha, reject H0;
alpha = 0.10
c_alpha=qt(1-alpha/2,n-k)
c_alpha

T_cdf=pt(abs(T), n-k) #https://stat.ethz.ch/R-manual/R-devel/library/stats/html/TDist.html
p_value=2*(1-T_cdf)
p_value


# 6.2
exper_squared = (wagedata$exper)^2
lm<-lm(log(wage) ~ educ + exper + exper_squared + tenure, data = wagedata)
summary(lm)

alpha = 0.10
n=length(wagedata$wage);
n
k=5
k
q=2
q

onecolumn=matrix(c(1),nrow = n);
X = matrix(c(onecolumn,wagedata$educ,wagedata$exper,exper_squared, wagedata$tenure),ncol=k,nrow=n);
beta_hat <- matrix(c(lm$coefficients['(Intercept)'],lm$coefficients['educ'],lm$coefficients['exper'],lm$coefficients['exper_squared'],lm$coefficients['tenure']),nrow=k);

#sigma_hat as in exercise 5
y_hat = X %*% beta_hat;
u_i_hat = log(wagedata$wage) - y_hat;
sigma_hat_squared = (1/(n-k)) * sum(u_i_hat^2);
sigma_hat = sqrt(sigma_hat_squared)
sigma_hat # residual standard error, n-k degrees of freedom

r=matrix(c(0,0))
R=matrix(c(0,0,0,0,1,0,0,1,0,0),nrow = q)

#H0 : beta3 = 0, beta4 = 0 versus H1 :beta3 != 0 or beta4 != 0

F=((t(R %*% beta_hat - r) %*% ginv(R %*% ginv(t(X) %*% X) %*% t(R)) %*% (R %*% beta_hat-r)) / sigma_hat_squared)*(1/q)
F

#If F > c_alpha, reject H0;

c_alpha=qf(1-alpha,q,n-k) #https://stat.ethz.ch/R-manual/R-devel/library/stats/html/Fdist.html
c_alpha

F_cdf=pf(F, q, n-k)
p_value=1-F_cdf
p_value

#6.3 - class next week

#6.4
exper_squared = (wagedata$exper)^2
lm<-lm(log(wage) ~ educ + exper + exper_squared + tenure, data = wagedata)
summary(lm)

alpha = 0.05
n=length(wagedata$wage);
n
k=5
k
q=4
q

onecolumn=matrix(c(1),nrow = n);
X = matrix(c(onecolumn,wagedata$educ,wagedata$exper,exper_squared, wagedata$tenure),ncol=k,nrow=n);
beta_hat <- matrix(c(lm$coefficients['(Intercept)'],lm$coefficients['educ'],lm$coefficients['exper'],lm$coefficients['exper_squared'],lm$coefficients['tenure']),nrow=k);

#sigma_hat as in exercise 5
y_hat = X %*% beta_hat;
u_i_hat = log(wagedata$wage) - y_hat;
sigma_hat_squared = (1/(n-k)) * sum(u_i_hat^2);
sigma_hat = sqrt(sigma_hat_squared)
sigma_hat # residual standard error, n-k degrees of freedom

r=matrix(c(0,0,0,0))
R=matrix(c(0,0,0,0,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1),nrow = q)

#H0 : beta2 = beta3 =... = betak = 0 versus H1 : betaj != 0 for at least one 2 <= j <= k

F=((t(R %*% beta_hat - r) %*% ginv(R %*% ginv(t(X) %*% X) %*% t(R)) %*% (R %*% beta_hat-r)) / sigma_hat_squared)*(1/q)
F

#If F > c_alpha, reject H0;

c_alpha=qf(1-alpha,q,n) #https://stat.ethz.ch/R-manual/R-devel/library/stats/html/Fdist.html
c_alpha

F_cdf=pf(F, q, n-k)
p_value=1-F_cdf
p_value


F=((R^2)/(1-(R^2))*((n-k)/q)) #?! TODO multiple R-squared from summary!
F

#6.5

#converted txt to csv manually
cobbdouglas = read.table("cobbdouglas.csv", sep = " ") 

#as in remark 3
#H0: alpha + beta = 1 versus H1: alpha + beta != 1
lm<-lm(log(cobbdouglas$output) ~ log(cobbdouglas$capital) + log(cobbdouglas$labor))
summary(lm)

k=3
alpha = 0.05
n=length(cobbdouglas$output);

onecolumn=matrix(c(1),nrow = n);
X = matrix(c(onecolumn,cobbdouglas$capital,cobbdouglas$labor),ncol=k,nrow=n);
beta_hat <- matrix(c(lm$coefficients['(Intercept)'],lm$coefficients['log(cobbdouglas$capital)'],lm$coefficients['log(cobbdouglas$labor)']),nrow=k);

#sigma_hat as in exercise 5
y_hat = X %*% beta_hat;
u_i_hat = log(cobbdouglas$output) - y_hat;
sigma_hat_squared = (1/(n-k)) * sum(u_i_hat^2);
sigma_hat = sqrt(sigma_hat_squared)
sigma_hat # residual standard error, n-k degrees of freedom

q = 1
R = t(matrix(c(0, 1, 1)))
r = 1

F=((t(R %*% beta_hat - r) %*% ginv(R %*% ginv(t(X) %*% X) %*% t(R)) %*% (R %*% beta_hat-r)) / sigma_hat_squared)*(1/q)
F

#If F > c_alpha, reject H0;

c_alpha=qf(1-alpha,q,n)
c_alpha

F_cdf=pf(F, q, n-k)
p_value=1-F_cdf
p_value

#6.7
n=1000;

df=1
plot(function(x) dt(x, df), -5, 5, ylim = c(0, 0.6), main = "t - Density", col="red")
par(new=TRUE)
df=2
plot(function(x) dt(x, df), -5, 5, ylim = c(0, 0.6), main = "t - Density", col="green")
par(new=TRUE)
df=10
plot(function(x) dt(x, df), -5, 5, ylim = c(0, 0.6), main = "t - Density", col="blue")
par(new=TRUE)

plot(function(x) dnorm(x), -5, 5, ylim = c(0, 0.6), col="black")

# Die Dichte der t-Verteilung konvergiert fr wachsende Freiheitsgrade gegen die Dichte der Standardnormalverteilung.




